// AXBoardMonitorCtl.cpp : Implementation of the CAXBoardMonitorCtrl ActiveX Control class.

#include "stdafx.h"
#include "AXBoardMonitor.h"
#include "AXBoardMonitorCtl.h"
#include "AXBoardMonitorPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CAXBoardMonitorCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CAXBoardMonitorCtrl, COleControl)
	//{{AFX_MSG_MAP(CAXBoardMonitorCtrl)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CAXBoardMonitorCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CAXBoardMonitorCtrl)
	DISP_PROPERTY_NOTIFY(CAXBoardMonitorCtrl, "host", m_host, OnHostChanged, VT_BSTR)
	DISP_PROPERTY_NOTIFY(CAXBoardMonitorCtrl, "port", m_port, OnPortChanged, VT_I2)
	DISP_PROPERTY_NOTIFY(CAXBoardMonitorCtrl, "useSSL", m_useSSL, OnUseSSLChanged, VT_I2)
	DISP_PROPERTY_NOTIFY(CAXBoardMonitorCtrl, "board", m_board, OnBoardChanged, VT_BSTR)
	DISP_PROPERTY_NOTIFY(CAXBoardMonitorCtrl, "alarms", m_alarms, OnAlarmsChanged, VT_I2)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CAXBoardMonitorCtrl, COleControl)
	//{{AFX_EVENT_MAP(CAXBoardMonitorCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CAXBoardMonitorCtrl, 1)
	PROPPAGEID(CAXBoardMonitorPropPage::guid)
END_PROPPAGEIDS(CAXBoardMonitorCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CAXBoardMonitorCtrl, "AXBOARDMONITOR.AXBoardMonitorCtrl.1",
	0xaf6825f0, 0xf6c, 0x4394, 0x92, 0x1a, 0x25, 0xd6, 0x45, 0xd5, 0x81, 0x9b)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CAXBoardMonitorCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DAXBoardMonitor =
		{ 0x757bd5cd, 0x1e2d, 0x46f9, { 0x9f, 0x72, 0x36, 0x29, 0x25, 0x8f, 0x21, 0xe4 } };
const IID BASED_CODE IID_DAXBoardMonitorEvents =
		{ 0xf055913c, 0x2634, 0x43d2, { 0xb4, 0xd8, 0x7d, 0xb6, 0x69, 0x5b, 0xd6, 0xcd } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwAXBoardMonitorOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CAXBoardMonitorCtrl, IDS_AXBOARDMONITOR, _dwAXBoardMonitorOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CAXBoardMonitorCtrl::CAXBoardMonitorCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CAXBoardMonitorCtrl

BOOL CAXBoardMonitorCtrl::CAXBoardMonitorCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_AXBOARDMONITOR,
			IDB_AXBOARDMONITOR,
			afxRegApartmentThreading,
			_dwAXBoardMonitorOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CAXBoardMonitorCtrl::CAXBoardMonitorCtrl - Constructor

CAXBoardMonitorCtrl::CAXBoardMonitorCtrl()
{
	InitializeIIDs(&IID_DAXBoardMonitor, &IID_DAXBoardMonitorEvents);

	// TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CAXBoardMonitorCtrl::~CAXBoardMonitorCtrl - Destructor

CAXBoardMonitorCtrl::~CAXBoardMonitorCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CAXBoardMonitorCtrl::OnDraw - Drawing function

void CAXBoardMonitorCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
	m_maindlg.MoveWindow(rcBounds, TRUE);
}


/////////////////////////////////////////////////////////////////////////////
// CAXBoardMonitorCtrl::DoPropExchange - Persistence support

void CAXBoardMonitorCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

	PX_String(pPX, _T("host"), m_host, CString("127.0.0.1"));
	PX_String(pPX, _T("board"), m_board, CString("demo"));
	PX_Short (pPX, _T("port"), m_port, 8444);
	PX_Short (pPX, _T("useSSL"), m_useSSL, 0);
	PX_Short (pPX, _T("alarms"), m_alarms, 1);
}


/////////////////////////////////////////////////////////////////////////////
// CAXBoardMonitorCtrl::GetControlFlags -
// Flags to customize MFC's implementation of ActiveX controls.
//
// For information on using these flags, please see MFC technical note
// #nnn, "Optimizing an ActiveX Control".
DWORD CAXBoardMonitorCtrl::GetControlFlags()
{
	DWORD dwFlags = COleControl::GetControlFlags();


	// The control will not be redrawn when making the transition
	// between the active and inactivate state.
	dwFlags |= noFlickerActivate;
	return dwFlags;
}


/////////////////////////////////////////////////////////////////////////////
// CAXBoardMonitorCtrl::OnResetState - Reset control to default state

void CAXBoardMonitorCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CAXBoardMonitorCtrl message handlers

int CAXBoardMonitorCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (COleControl::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	strcpy(m_maindlg.remoteIP, m_host.GetBuffer(0));
	strcpy(m_maindlg.board, m_board.GetBuffer(0));
	m_maindlg.remotePort = m_port;
	m_maindlg.useSSL = m_useSSL;
	m_maindlg.alarms = m_alarms;
	m_maindlg.Create(IDD_MAINVIEW, this);
	
	return 0;
}

void CAXBoardMonitorCtrl::OnHostChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CAXBoardMonitorCtrl::OnPortChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CAXBoardMonitorCtrl::OnUseSSLChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CAXBoardMonitorCtrl::OnBoardChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CAXBoardMonitorCtrl::OnAlarmsChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}
