/*
 * Copyright (c) 2003 by Diamond Systems Corporation. All Rights Reserved.
 * Use of this source code is subject to the terms of Diamond Systems 
 * Software License Agreement.
 *
 * DALI C/C++ Client demo program
 * See the DALI user manual for information on this API
 *
 * DALI client software must be installed on your system or this program
 * will not compile.  By default it will connect to a DALI server running
 * on your system.  Edit the env.service parameter below to talk to a
 * DALI server on a remote system.
 */

#include <stdio.h>
#include "dalic.h"

int main(int argc, char *argv[])
{
	DALIENV env; // DALI client handle
	int channel; // Channel to sample
	int value; // Value to output
	int result; // Holds the error code

	/* Initialize the client.  Always call this first */
	DALIInit(&env);

	/* Service URL for the DALI server.  Switch to "https" for SSL
	 * encryption.  Change IP to talk to a different server */
	env.service = "http://127.0.0.1:8444/dali/soap/demo";

	channel = 0; // Channel 0
	value = 1024; // Value converted on DA channel

	result = DALIDAConvert(&env, channel, value);
	if ( result )
		printf("DALI error: %s (%d)\n", env.last_error, result);
	else
		printf("DALI: success\n");

	/* Closes any network connections and frees memory associated
	 * with the client handle */
	DALIFree(&env);
	return 0;
}

