/*
 * Copyright (c) 2003 by Diamond Systems Corporation. All Rights Reserved.
 * Use of this source code is subject to the terms of Diamond Systems 
 * Software License Agreement.
 *
 * DALI C/C++ Client demo program
 * See the DALI user manual for information on this API
 *
 * DALI client software must be installed on your system or this program
 * will not compile.  By default it will connect to a DALI server running
 * on your system.  Edit the env.service parameter below to talk to a
 * DALI server on a remote system.
 */

#include <stdio.h>
#include "dalic.h"

int main(int argc, char *argv[])
{
	DALIENV env; // DALI client handle
	int lowchannel, highchannel; // Channel to sample
	int values[2]; // Values to output
	int result; // Holds the error code

	/* Initialize the client.  Always call this first */
	DALIInit(&env);

	/* Service URL for the DALI server.  Switch to "https" for SSL
	 * encryption.  Change IP to talk to a different server */
	env.service = "http://127.0.0.1:8444/dali/soap/demo";

	lowchannel = 0;
	highchannel = 1;
	values[0] = 1024; // Converted on first channel
	values[1] = 2048; // Converted on second channel

	result = DALIDAConvertScan(&env, lowchannel, highchannel, values);
	if ( result )
		printf("DALI error: %s (%d)\n", env.last_error, result);
	else
		printf("DALI: success\n");

	/* Closes any network connections and frees memory associated
	 * with the client handle */
	DALIFree(&env);
	return 0;
}

