// MFCServerInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFCServerInfo.h"
#include "MFCServerInfoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMFCServerInfoDlg dialog

CMFCServerInfoDlg::CMFCServerInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFCServerInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMFCServerInfoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFCServerInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMFCServerInfoDlg)
	DDX_Control(pDX, IDC_SERVERINFO, m_info);
	DDX_Control(pDX, IDC_REMOTEIP, m_remoteip);
	DDX_Control(pDX, IDC_PORT, m_port);
	DDX_Control(pDX, IDC_GETINFO, m_getinfo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMFCServerInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CMFCServerInfoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_GETINFO, OnGetinfo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFCServerInfoDlg message handlers

BOOL CMFCServerInfoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	m_remoteip.SetWindowText(DALI_IP);
	m_port.SetWindowText(DALI_PORT);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFCServerInfoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFCServerInfoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMFCServerInfoDlg::HandleError(CDali* dali, int rc, char* str)
{
	if (rc)
    {
		char buffer[1024];
        sprintf(buffer, "%s Error [%d]: %s\n", str, rc, dali->GetLastErrorString());
		MessageBox(buffer, "DALI Error"); 
		exit(rc);
    }
}

void CMFCServerInfoDlg::OnGetinfo() 
{
	CDali dali;
	UINT i;

	m_info.DeleteAllItems();

	//Get the information entered into the edit fields

	char dali_ip[1024];
	char dali_port[1024];

	m_remoteip.GetWindowText(dali_ip, 1024);
	m_port.GetWindowText(dali_port, 1024);

	//Initialize the CDali object with the IP and port

	HandleError(&dali, dali.SetServer("192.168.1.252", 8443, 1), "dali.SetServer()");

	//Get the number of boards on the server

	UINT numboards;

	HandleError(&dali, dali.GetNumBoards(&numboards), "dali.GetNumBoards()");

	//Now get information for each board.

	for (UINT b = 0; b < numboards; b++)
	{
		DALIBOARD db;
		UINT totalchans = 0;

		UINT numchan[5] = { 0,0,0,0,0 };
		
		//Retrieve the board info and number of channels.

		HandleError(&dali, dali.GetBoardInfo(b, &db), "dali.GetBoardInfo()");
		HandleError(&dali, dali.GetNumChannels(b, &totalchans), "dali.GetNumChannels()");


		//Now get all channel information.

		for (UINT ch = 0; ch < totalchans; ch++)
		{
			DALICHANNEL dc;
			dali.GetChannelInfo(b, ch, &dc);
			numchan[dc.type]++;			
		}

		//Display board info.

		char buffer[1024];
		sprintf(buffer, "Board %d", b);

		HTREEITEM par = m_info.InsertItem(buffer, 0, 0);
	
		
		sprintf(buffer, "Board name: %s", strupr(db.board));
		m_info.InsertItem(buffer, 0, 0, par);
		
		sprintf(buffer, "Board type: %d", db.boardtype);
		m_info.InsertItem(buffer, 0, 0, par);
		
		sprintf(buffer, "Base address: %Xh", db.baseaddress);
		m_info.InsertItem(buffer, 0, 0, par);
	
		sprintf(buffer, "Total channels: %d", totalchans);
		HTREEITEM chpar = m_info.InsertItem(buffer, 0, 0, par);

		sprintf(buffer, "A/D channels: %d", numchan[1]);
		HTREEITEM chparAD = m_info.InsertItem(buffer, 0, 0, chpar);

		for (i = 0; i < totalchans; i++)
		{
			DALICHANNEL dc;
			dali.GetChannelInfo(b, i, &dc);
			if (dc.type == 1)
			{
				sprintf(buffer, "Channel %d: %s", dc.channel, dc.security ? (dc.security == 1 ? "PUBLIC" : "LOGIN") : "DISABLED");
				m_info.InsertItem(buffer, 0, 0, chparAD);
			}
		}
		
		sprintf(buffer, "D/A channels: %d", numchan[2]);
		HTREEITEM chparDA = m_info.InsertItem(buffer, 0, 0, chpar);
		
		for (i = 0; i < totalchans; i++)
		{
			DALICHANNEL dc;
			dali.GetChannelInfo(b, i, &dc);
			if (dc.type == 2)
			{
				sprintf(buffer, "Channel %d: %s", dc.channel, dc.security ? (dc.security == 1 ? "PUBLIC" : "LOGIN") : "DISABLED");
				m_info.InsertItem(buffer, 0, 0, chparDA);
			}
		}

		sprintf(buffer, "DIO-in channels: %d", numchan[3]);
		HTREEITEM chparDIOI = m_info.InsertItem(buffer, 0, 0, chpar);
		
		for (i = 0; i < totalchans; i++)
		{
			DALICHANNEL dc;
			dali.GetChannelInfo(b, i, &dc);
			if (dc.type == 3)
			{
				sprintf(buffer, "Channel %d: %s", dc.channel, dc.security ? (dc.security == 1 ? "PUBLIC" : "LOGIN") : "DISABLED");
				m_info.InsertItem(buffer, 0, 0, chparDIOI);
			}
		}

		sprintf(buffer, "DIO-out channels: %d", numchan[4]);
		HTREEITEM chparDIOO = m_info.InsertItem(buffer, 0, 0, chpar);

		for (i = 0; i < totalchans; i++)
		{
			DALICHANNEL dc;
			dali.GetChannelInfo(b, i, &dc);
			if (dc.type == 4)
			{
				sprintf(buffer, "Channel %d: %s", dc.channel, dc.security ? (dc.security == 1 ? "PUBLIC" : "LOGIN") : "DISABLED");
				m_info.InsertItem(buffer, 0, 0, chparDIOO);
			}
		}

		m_info.Expand(par, TVE_EXPAND);
		m_info.Expand(chpar, TVE_EXPAND);
	}

}
