/*

	DALIEditCtrl.cpp
	
	This is the implementation file for CDALIEditCtrl

	(c) Diamond Systems Corporation 2003

	http://www.diamondsystems.com

	(c) Copyright 2003 Diamond Systems Corporation. Use of this source code
	is subject to the terms of Diamond Systems' Software License Agreement.
	Diamond Systems provides no warranty of proper performance if this
	source code is modified.

	
*/


#include "dalictrl.h"
#include "dali_w32.h"


/////////////////////////////////////////////////////////////////////////////
// CDALIEditCtrl

CDALIEditCtrl::CDALIEditCtrl()
{
	CEdit();	
	
	dali = NULL;

	last_error_code = 0;
	last_error_str[0] = 0;

	dt = DALICTRL_INTEGER;
}

CDALIEditCtrl::~CDALIEditCtrl()
{
	
}

BEGIN_MESSAGE_MAP(CDALIEditCtrl, CEdit)
	ON_WM_ERASEBKGND()
	ON_MESSAGE(DALI_NOTIFY, OnDALI)
END_MESSAGE_MAP()

BOOL CDALIEditCtrl::OnEraseBkgnd(CDC* pDC)
{
	return 1;
}

LRESULT CDALIEditCtrl::OnDALI(WPARAM code, LPARAM data)
{
	DALI_DATA* d = (DALI_DATA*)data;
	char buffer[32];
	double val;

	switch (code)
	{
	case DALI_CMD_ERROR:
		last_error_code = d->error;
		strcpy(last_error_str, d->error_str);
		EnableWindow(FALSE);
		break;

	case DALI_CMD_REGISTERED:
		dali = (CDali*)d->lpCDALI;
		last_error_code = 0;
		last_error_str[0] = 0;
		EnableWindow(TRUE);
		break;

	default:
		
		val = Convert(d->values[0]);

		switch (dt)
		{
		case DALICTRL_ON_OFF:
			sprintf(buffer, val ? "ON" : "OFF");
			break;
		case DALICTRL_BOOLEAN:
			sprintf(buffer, val ? "TRUE" : "FALSE");
			break;
		case DALICTRL_INTEGER:
			sprintf(buffer, "%d", (int)val);
			break;
		case DALICTRL_DOUBLE:
			sprintf(buffer, "%lf", val);
			break;
		}

		EnableWindow(TRUE);
		SetWindowText(buffer);
	}

	return 1;
}

double CDALIEditCtrl::Convert(double value, BOOL incoming)
{
	return value;
}

void CDALIEditCtrl::SetDisplayType(int dispType)
{
	dt = dispType;
}


LPTSTR CDALIEditCtrl::GetLastDALIError(UINT* code)
{
	*code = last_error_code;
	return last_error_str;
}