/*

	DALIProgressCtrl.cpp
	
	This is the implementation file for CDALIProgressCtrl

	(c) Diamond Systems Corporation 2003

	http://www.diamondsystems.com

	(c) Copyright 2003 Diamond Systems Corporation. Use of this source code
	is subject to the terms of Diamond Systems' Software License Agreement.
	Diamond Systems provides no warranty of proper performance if this
	source code is modified.

	
*/

#include "dalictrl.h"
#include "dali_w32.h"


/////////////////////////////////////////////////////////////////////////////
// CDALIProgressCtrl

CDALIProgressCtrl::CDALIProgressCtrl()
{
	CProgressCtrl();	
	
	dali = NULL;

	last_error_code = 0;
	last_error_str[0] = 0;
}

CDALIProgressCtrl::~CDALIProgressCtrl()
{
	
}

BEGIN_MESSAGE_MAP(CDALIProgressCtrl, CProgressCtrl)
	ON_WM_ERASEBKGND()
	ON_MESSAGE(DALI_NOTIFY, OnDALI)
END_MESSAGE_MAP()

BOOL CDALIProgressCtrl::OnEraseBkgnd(CDC* pDC)
{
	return CWnd::OnEraseBkgnd(pDC);
}

LRESULT CDALIProgressCtrl::OnDALI(WPARAM code, LPARAM data)
{
	DALI_DATA* d = (DALI_DATA*)data;

	switch (code)
	{
	case DALI_CMD_ERROR:
		last_error_code = d->error;
		strcpy(last_error_str, d->error_str);
		EnableWindow(FALSE);
		break;

	case DALI_CMD_REGISTERED:
		dali = (CDali*)d->lpCDALI;
		last_error_code = 0;
		last_error_str[0] = 0;
		EnableWindow(TRUE);
		break;

	default:
		EnableWindow(TRUE);
		SetPos( (int)Convert(d->values[0]) );		
	}

	return 1;
}

double CDALIProgressCtrl::Convert(double value, BOOL incoming)
{
	return value;
}


LPTSTR CDALIProgressCtrl::GetLastDALIError(UINT* code)
{
	*code = last_error_code;
	return last_error_str;
}