/*

	DALIStaticCtrl.cpp
	
	This is the implementation file for CDALIStaticCtrl

	(c) Diamond Systems Corporation 2003

	http://www.diamondsystems.com

	(c) Copyright 2003 Diamond Systems Corporation. Use of this source code
	is subject to the terms of Diamond Systems' Software License Agreement.
	Diamond Systems provides no warranty of proper performance if this
	source code is modified.

	
*/

#include "dalictrl.h"
#include "dali_w32.h"


/////////////////////////////////////////////////////////////////////////////
// CDALIStaticCtrl

CDALIStaticCtrl::CDALIStaticCtrl()
{
	CStatic();	
	
	dali = NULL;

	last_error_code = 0;
	last_error_str[0] = 0;

	dt = DALICTRL_INTEGER;
}

CDALIStaticCtrl::~CDALIStaticCtrl()
{
	
}

BEGIN_MESSAGE_MAP(CDALIStaticCtrl, CStatic)
	ON_WM_ERASEBKGND()
	ON_MESSAGE(DALI_NOTIFY, OnDALI)
END_MESSAGE_MAP()

BOOL CDALIStaticCtrl::OnEraseBkgnd(CDC* pDC)
{
	return 1;
}

LRESULT CDALIStaticCtrl::OnDALI(WPARAM code, LPARAM data)
{
	DALI_DATA* d = (DALI_DATA*)data;
	char buffer[32];
	double val;

	switch (code)
	{
	case DALI_CMD_ERROR:
		last_error_code = d->error;
		strcpy(last_error_str, d->error_str);
		EnableWindow(FALSE);
		break;

	case DALI_CMD_REGISTERED:
		dali = (CDali*)d->lpCDALI;
		last_error_code = 0;
		last_error_str[0] = 0;
		EnableWindow(TRUE);
		break;

	default:
		
		val = Convert(d->values[0]);

		switch (dt)
		{
		case DALICTRL_ON_OFF:
			sprintf(buffer, val ? "ON" : "OFF");
			break;
		case DALICTRL_BOOLEAN:
			sprintf(buffer, val ? "TRUE" : "FALSE");
			break;
		case DALICTRL_INTEGER:
			sprintf(buffer, "%d", (int)val);
			break;
		case DALICTRL_DOUBLE:
			sprintf(buffer, "%lf", val);
			break;
		}

		EnableWindow(TRUE);
		SetWindowText(buffer);
	}

	return 1;
}

double CDALIStaticCtrl::Convert(double value, BOOL incoming)
{
	return value;
}

void CDALIStaticCtrl::SetDisplayType(int dispType)
{
	dt = dispType;
}


LPTSTR CDALIStaticCtrl::GetLastDALIError(UINT* code)
{
	*code = last_error_code;
	return last_error_str;
}